#include <iostream>
#include "SDL/SDL.h"
//Use of SDL library has been learnt from lazyfoo.net/SDL_tutorials and Youtube videos
int displayfirstscreen();
int displaysecondscreen();
int displaythirdscreen();
int keyboardormouse();
void gridkey(int &num,int &grid,int &use);
int validatemove(int playerindex,int z);
void gameoverscreen(int a);
void applybutton(int x,int y,SDL_Surface* source, SDL_Surface* destination );
void displayinstructionscreen();
int main( int argc, char* args[] )
{

    int i,grid,num,use;
    for(i=0;;)
    {
        grid=displayfirstscreen();//display options to play or exit
        if(grid==-1)
        {
            return 0;
        }
        if(grid==1)
        {
            displayinstructionscreen();//display screen for instructions
            continue;

        }
        num=displaysecondscreen();//display screen to choose no. of players
        if(num==-1)
        {
            break;
        }
        use=keyboardormouse();//display screen to choose mode of play
        grid=displaythirdscreen();//display screen to choose size of screen

        if(grid==-1)
        {
            break;
        }

        gridkey(num,grid,use);//function to create a grid and playarea

        continue;

        if (use==-1)
        {
            break;
        }

    }
    return 0;
}
int displayfirstscreen()
{
    /*Displays a screen for the player to choose between 'play', 'instruction' and 'quit' options
    'play' option continues the game
    'instruction' option displays instructions regarding the game
    'quit' option exits the game
    the function returns the value 0 , 1 or -1 if 'play', 'instruction' or 'quit' option is selected respectively
    */
    SDL_Event e;//event structure in SDL
    SDL_Surface* backdisplay1= NULL;//initialising images pointers
    SDL_Surface* screen= NULL;

    SDL_Init( SDL_INIT_EVERYTHING );//initialising everything

    if( SDL_Init( SDL_INIT_EVERYTHING ) == -1 )
    {
        return -1;
    }
    SDL_WM_SetCaption( "CHAIN REACTION", NULL );
    screen = SDL_SetVideoMode( 640, 480, 32, SDL_SWSURFACE );//loading screen of size 640x480
    backdisplay1=SDL_LoadBMP("background1.bmp");//loading image

    SDL_BlitSurface(backdisplay1,NULL,screen,NULL);//applying background on the screen
    SDL_Flip(screen);//refresh the screen
    while(true)
    {
        if(SDL_PollEvent(&e))//event
        {
            if( e.type == SDL_MOUSEBUTTONDOWN )//event of mousebutton press
            {
                if( e.button.button == SDL_BUTTON_LEFT )//left click
                {
                    int i = e.button.x;//x coordinate of clicked position
                    int j = e.button.y;//y coordinate of clicked position
                    if((i>320)&&(i<640))
                    {
                        if((j>160)&&(j<240))//coordinates of option play
                        {
                            return 0;
                        }
                        if((j>240)&&(j<320))//coordinates of option instructions
                        {
                            return 1;
                        }
                        if((j>320)&&(j<400))//coordinates of option quit                       {
                            return -1;
                    }
                }
            }
        }

    }

    SDL_FreeSurface( backdisplay1 );
}

int displaysecondscreen()
{
    /* Displays a screen to the number of players to play the game.
    there can be 2, 3, 4 players according to player specification
    the function returns values = 2, 3, or 4 depending upon input received
    */
    SDL_Event e;
    SDL_Surface* backdisplay2= NULL;
    SDL_Surface* screen= NULL;

    SDL_Init( SDL_INIT_EVERYTHING );

    if( SDL_Init( SDL_INIT_EVERYTHING ) == -1 )
    {
        return -1;
    }
    SDL_WM_SetCaption( "SELECT NUMBER OF PLAYERS", NULL );
    screen = SDL_SetVideoMode( 640, 480, 32, SDL_SWSURFACE );//load screen of size 640x480
    backdisplay2=SDL_LoadBMP("background2.bmp");//loading background image

    SDL_BlitSurface(backdisplay2,NULL,screen,NULL);//load image on screen
    SDL_Flip(screen);


    while(true)
    {
        if(SDL_PollEvent(&e))
            if( e.type == SDL_MOUSEBUTTONDOWN )//event of mousebutton down
            {
                if( e.button.button == SDL_BUTTON_LEFT )//left click
                {
                    int i = e.button.x;//x coordinate of clicked position
                    int j = e.button.y;//y coordinate of clicked position
                    if((i>320)&&(i<640))
                    {
                        if((j>160)&&(j<240))//coordinates of choosing 2 players
                        {
                            return 2;
                        }
                        if((j>240)&&(j<320))//coordinates of choosing 3 players
                        {
                            return 3;
                        }
                        if((j>320)&&(j<400))//coordinates of choosing 4 players
                        {
                            return 4;
                        }
                    }
                }


            }
    }
    SDL_FreeSurface( backdisplay2 );//free the screen

}
int keyboardormouse()
{
    /*Displays a screen for the user to choose between mouse or keyboard gameplay within the game
    the function returns value = 0 or 1 if keyboard or mouse is chosen respectively.
    */
    SDL_Event e;//event
    SDL_Surface* backkeyboardormouse= NULL;//initialising images
    SDL_Surface* screen= NULL;

    SDL_Init( SDL_INIT_EVERYTHING );//initialising everything

    if( SDL_Init( SDL_INIT_EVERYTHING ) == -1 )
    {
        return -1;
    }
    SDL_WM_SetCaption( "CHOOSE INPUT DEVICE", NULL );
    screen = SDL_SetVideoMode( 640, 480, 32, SDL_SWSURFACE );//loading screen of size 640x480
    backkeyboardormouse= SDL_LoadBMP("backkeymouse.bmp");//declaring image

    SDL_BlitSurface(backkeyboardormouse,NULL,screen,NULL);//loading image on the screen
    SDL_Flip(screen);//update screen
    while (true)
    {
        if(SDL_PollEvent(&e))//occurance of event
        {
            if( e.type == SDL_MOUSEBUTTONDOWN )//event of mousebutton down
            {
                if( e.button.button == SDL_BUTTON_LEFT )//left click
                {
                    int i = e.button.x;//x coordinate of position clicked
                    int j = e.button.y;//y coordinate of position clicked
                    if((i>320)&&(i<640))
                    {
                        if((j>160)&&(j<240))//coordinates of choosing keyboard
                        {
                            return 3;
                        }
                        if((j>320)&&(j<400))//coordinates of choosing mouse
                        {
                            return 2;
                        }
                    }
                }
            }

        }
    }
    SDL_FreeSurface( backkeyboardormouse );//freeing the surface

}
int displaythirdscreen()
{
    /*Displays a screen for the user to choose the size of the grid.
    the grid can be 5x5,8x8,10x10 according to user requirement.
    the function returns value = 5, 8, or 10 depending upon the size of the grid chosen.
    */
    SDL_Event e;
    SDL_Surface* backdisplay3= NULL;
    SDL_Surface*screen= NULL;

    SDL_Init( SDL_INIT_EVERYTHING );

    if( SDL_Init( SDL_INIT_EVERYTHING ) == -1 )
    {
        return -1;
    }
    SDL_WM_SetCaption( "CHOOSE SIZE OF GRID ", NULL );
    screen = SDL_SetVideoMode( 640, 480, 32, SDL_SWSURFACE );//loading screen of size 640x480
    backdisplay3=SDL_LoadBMP("background3.bmp");//loading image


    SDL_BlitSurface(backdisplay3,NULL,screen,NULL);//applying image on screen
    SDL_Flip(screen);//updating screen


    while(true)
    {

        if(SDL_PollEvent(&e))//event
        {
            if( e.type == SDL_MOUSEBUTTONDOWN )//event of mousebutton down
            {
                if( e.button.button == SDL_BUTTON_LEFT )//left click
                {
                    int i = e.button.x;//x coordinate of clicked position
                    int j = e.button.y;//y coordinate of clicked position
                    if((i>320)&&(i<640))
                    {
                        if((j>160)&&(j<240))// coordinates for option of 5x5 grid
                        {
                            return 5;
                        }
                        if((j>240)&&(j<320))// coordinates for option of 8x8 grid
                        {
                            return 8;
                        }
                        if((j>320)&&(j<400))// coordinates for option of 10x10 grid
                        {
                            return 10;
                        }
                    }
                }
            }
        }
    }
    SDL_FreeSurface( backdisplay3 );
}
void gridkey(int &num,int &grid,int &use)
{
    /*This function creates a grid of required specified size and begins the game.
    if there is only a single colored atom visible on the screen it calls the gameoverscreen function.
    */
    //partial code referred from lazyfoo.com/SDL_tutorial
    SDL_Event event;
    //declaring image pointers
    SDL_Surface* screen = NULL;
    SDL_Surface* oneblue = NULL;
    SDL_Surface* twoblue =NULL;
    SDL_Surface* threeblue = NULL;
    SDL_Surface* oneyellow = NULL;
    SDL_Surface* twoyellow = NULL;
    SDL_Surface* threeyellow = NULL;
    SDL_Surface* onered = NULL;
    SDL_Surface* twored = NULL;
    SDL_Surface* threered = NULL;
    SDL_Surface* onegreen = NULL;
    SDL_Surface* twogreen = NULL;
    SDL_Surface* threegreen = NULL;
    SDL_Surface* marker = NULL;
    SDL_Surface* singlebackblue= NULL;
    SDL_Surface* singlebackyellow= NULL;
    SDL_Surface* singlebackred= NULL;
    SDL_Surface* singlebackgreen= NULL;
    SDL_Init( SDL_INIT_EVERYTHING );
    if( SDL_Init( SDL_INIT_EVERYTHING ) == -1 )
    {
        return;
    }
    screen = SDL_SetVideoMode( 64*grid, 48*grid, 32, SDL_SWSURFACE );//load screen of size 640x480
    if( screen == NULL )
    {
        return;
    }
    //setting caption according to size of grid
    if(grid==5) SDL_WM_SetCaption( "CHAIN REACTION 5x5", NULL );
    if(grid==8) SDL_WM_SetCaption( "CHAIN REACTION 8x8", NULL );
    if(grid==10) SDL_WM_SetCaption( "CHAIN REACTION 10x10", NULL );
    //loading images
    oneblue =SDL_LoadBMP("oneblue.bmp");
    oneyellow= SDL_LoadBMP("oneyellow.bmp");
    onered= SDL_LoadBMP("onered.bmp");
    onegreen= SDL_LoadBMP("onegreen.bmp");
    threeblue=SDL_LoadBMP("threeblue.bmp");
    threeyellow=SDL_LoadBMP("threeyellow.bmp");
    threered=SDL_LoadBMP("threered.bmp");
    threegreen=SDL_LoadBMP("threegreen.bmp");
    twoblue=SDL_LoadBMP("twoblue.bmp");
    twoyellow=SDL_LoadBMP("twoyellow.bmp");
    twored=SDL_LoadBMP("twored.bmp");
    twogreen=SDL_LoadBMP("twogreen.bmp");
    marker=SDL_LoadBMP("white.bmp");
    singlebackblue=SDL_LoadBMP("singlebackblue.bmp");
    singlebackyellow=SDL_LoadBMP("singlebackyellow.bmp");
    singlebackred=SDL_LoadBMP("singlebackred.bmp");
    singlebackgreen=SDL_LoadBMP("singlebackgreen.bmp");
    struct playerinfo
    {
        int playerid;
        bool playstat;
        int nofballs;
        int count;
        playerinfo(int i)
        {
            playerid=i;
            playstat=true;
            nofballs=0;
            count=0;
            return;
        }
    };

    bool quit = true;//quit turns to false when game ends
    int p=0,q=0,i=0,j=0,playerindex=1,t,u,elim=0;
    int Grid[20][20];//2-D array for storing information about grid
    //declaring functions which are used
    void executemove(int x,int y,int Grid[20][20],int &playerindex,int &grid);
    void applyimage(int a,int b,int &playerindex,SDL_Surface* atoms, SDL_Surface* destination);
    int criticalmass[10][10];
    playerinfo player1(1),player2(2),player3(3),player4(4);
//initialising every cell of grid to 0
    for(int t=0; t<10; t++)
    {
        for(int u=0; u<10; u++)
        {
            Grid[t][u]=0;
        }
    }
    int turns=0;
    while(quit)
    {
        if(turns>num)//if all players have had their chance at least once
        {
            int z[5]= {0,0,0,0,0};//array for number of cells for every player
            for(int w=0; w<grid; w++)
            {
                for(int v=0; v<grid; v++)
                {
                    int g=Grid[w][v]/100;//occupied playerid of cell
                    if(g!=0)//if cell is occupied by some player
                        z[g]++;//update no of cells in the array
                }
            }
            int r=0;

            if(z[playerindex]==0)//if current player is eliminated update playerindex
            {
                playerindex++;

                if(playerindex==(num+1))playerindex=1;
            }




        }
        for(int t=0; t<10; t++)
        {
            for(int u=0; u<10; u++)
            {
                if((Grid[t][u]==0)&&((t*64!=p)||(u*48!=q)) )//if cell is empty and marker is not there
                {
                    SDL_Rect off;
                    off.x = t*64;
                    off.y =u*48;
//load background according to player playing
                    if(playerindex==1)
                    {
                        SDL_BlitSurface(singlebackblue,NULL,screen,&off);
                    }
                    if(playerindex==2)
                    {
                        SDL_BlitSurface(singlebackyellow,NULL,screen,&off);
                    }
                    if(playerindex==3)
                    {
                        SDL_BlitSurface(singlebackred,NULL,screen,&off);
                    }
                    if(playerindex==4)
                    {
                        SDL_BlitSurface(singlebackgreen,NULL,screen,&off);
                    }

                    SDL_Flip(screen);

                }
                //if cell is occupied load image accordingly
                //units place of Grid[][] indicate no. of atoms in cell
                //hundreds place of Grid[][] indicate occupied player's index
                if(Grid[t][u]==101)//if atoms=1 and occupied playerindex=1
                {
                    applyimage(t,u,playerindex,oneblue,screen);
                }
                if(Grid[t][u]==201)//if atoms=1 and occupied playerindex=2
                {
                    applyimage(t,u,playerindex,oneyellow,screen);
                }
                if(Grid[t][u]==301)//if atoms=1 and occupied playerindex=3
                {
                    applyimage(t,u,playerindex,onered,screen);
                }
                if(Grid[t][u]==401)//if atoms=1 and occupied playerindex=4
                {
                    applyimage(t,u,playerindex,onegreen,screen);
                }
                if(Grid[t][u]==102)//if atoms=2 and occupied playerindex=1
                {
                    applyimage(t,u,playerindex,twoblue,screen) ;
                }
                if(Grid[t][u]==202)//if atoms=2 and occupied playerindex=2
                {
                    applyimage(t,u,playerindex,twoyellow,screen);
                }
                if(Grid[t][u]==302)//if atoms=2 and occupied playerindex=3
                {
                    applyimage(t,u,playerindex,twored,screen) ;
                }
                if(Grid[t][u]==402)//if atoms=2and occupied playerindex=4
                {
                    applyimage(t,u,playerindex,twogreen,screen);
                }
                if(Grid[t][u]==103)//if atoms=3 and occupied playerindex=1
                {
                    applyimage(t,u,playerindex,threeblue,screen);
                }
                if(Grid[t][u]==203)//if atoms=3 and occupied playerindex=2
                {
                    applyimage(t,u,playerindex,threeyellow,screen);
                }
                if(Grid[t][u]==303)//if atoms=3 and occupied playerindex=3
                {
                    applyimage(t,u,playerindex,threered,screen) ;
                }
                if(Grid[t][u]==403)//if atoms=3 and occupied playerindex=4
                {
                    applyimage(t,u,playerindex,threegreen,screen);
                }
            }
        }

        if(use==3)//if chosen mode of play is keyboard
        {
            {
                //when marker moves out of grid this part of code brings that back to edges
                if(p<0)
                {
                    p=(64*(grid-1));
                    j=(grid-1);
                }
                if(p>(64*(grid-1)))
                {
                    p=0;
                    j=0;
                }
                if(q<0)
                {
                    q=(48*(grid-1));
                    i=(grid-1);
                }
                if(q>(48*(grid-1)))
                {
                    q=0;
                    i=0;
                }
            }
            //load marker
            SDL_Rect offset;
            offset.x =p;
            offset.y=q;
            SDL_BlitSurface(marker,NULL,screen,&offset);
            SDL_Flip(screen);
        }

        while(SDL_PollEvent(&event))//if any event occurs
        {
            if(use==3)//if mode of play is keyboard
            {
                if( event.type == SDL_KEYDOWN )//event of keypress
                    switch( event.key.keysym.sym )
                    {
                    case SDLK_UP://if up key is pressed change marker position
                        q=q-48;
                        i--;
                        break;
                    case SDLK_DOWN://if down key is pressed change marker position
                        q=q+48;
                        i++;
                        break;
                    case SDLK_LEFT://if left key is pressed change marker position
                        p=p-64;
                        j--;
                        break;
                    case SDLK_RIGHT://if right key is pressed change marker position
                        p=p+64;
                        j++;
                        break;
                    case SDLK_a://if a is pressed
                    {
                        int z=Grid[j][i];
                        int mov=validatemove(playerindex,z);//validates the move
                        if(mov==0)//if move is valid
                        {
                            elim++;
                            turns++;
                            if(i<(grid-1) && i>0 && j<(grid-1) && j>0)//if cell is in the middle
                            {
                                if(Grid[j][i]==0)//if cell is empty
                                {//update atoms and update playerindex
                                    Grid[j][i]=(playerindex*100+1);
                                    playerindex++;
                                    if(playerindex==num+1)
                                    {
                                        playerindex=1;
                                    }
                                    break;
                                }
                                if(Grid[j][i]==(playerindex*100+1))//if cell contains one atom
                                {//update atoms and update playerindex
                                    Grid[j][i]=(playerindex*100+2);
                                    playerindex++;
                                    if(playerindex==num+1)
                                    {
                                        playerindex=1;
                                    }
                                    break;
                                }
                                if(Grid[j][i]==(playerindex*100+2))//if cell contains 2 atoms
                                {//update atoms and update playerindex
                                    Grid[j][i]=(playerindex*100+3);
                                    playerindex++;
                                    if(playerindex==num+1)
                                    {
                                        playerindex=1;
                                    }
                                    break;
                                }
                                if(Grid[j][i]==(playerindex*100+3)) //if cell contains 3 atoms
                                {//initiate the reaction
                                    Grid[j][i]=0;
                                    executemove(j,i,Grid,playerindex,grid);
                                    playerindex++;
                                    if(playerindex==num+1)
                                    {
                                        playerindex=1;
                                    }
                                    break;
                                }
                            }
                            //if cell is on the edges
                            if(((i==0 || i==(grid-1)) && j<(grid-1) && j>0) || ((j==0 || j==(grid-1)) && i<(grid-1) && i>0))
                            {
                                if(Grid[j][i]==0)//if cell is empty
                                {//update atoms and update playerindex
                                    Grid[j][i]=(playerindex*100+1);
                                    playerindex++;
                                    if(playerindex==num+1)
                                    {
                                        playerindex=1;
                                    }
                                    break;
                                }
                                if(Grid[j][i]==(playerindex*100+1))//if cell contains 1 atoms
                                {//update atoms and update playerindex
                                    Grid[j][i]=(playerindex*100+2);
                                    playerindex++;
                                    if(playerindex==num+1)
                                    {
                                        playerindex=1;
                                    }
                                    break;
                                }
                                if(Grid[j][i]==(playerindex*100+2))//if cell contains 2 atoms
                                {//initiate the reaction
                                    Grid[j][i]=0;
                                    executemove(j,i,Grid,playerindex,grid);
                                    playerindex++;
                                    if(playerindex==num+1)
                                    {
                                        playerindex=1;
                                    }
                                    break;
                                }
                            }
                            //cell is on corner
                            if((i==0 && j==0) || (i==0 && j==(grid-1)) || (i==(grid-1) && j==0) || (i==(grid-1) && j==(grid-1)))
                            {
                                if(Grid[j][i]==0)//if cell is empty
                                {//update atoms and update playerindex
                                    Grid[j][i]=(playerindex*100+1);
                                    playerindex++;
                                    if(playerindex==num+1)
                                    {
                                        playerindex=1;
                                    }
                                    break;
                                }
                                if(Grid[j][i]==(playerindex*100+1))//if cell contains 1 atoms
                                {//initiate the reaction
                                    Grid[j][i]=0;
                                    executemove(j,i,Grid,playerindex,grid);
                                    playerindex++;
                                    if(playerindex==num+1)
                                    {
                                        playerindex=1;
                                    }
                                    break;
                                }
                            }
                        }

                        if(mov==-1)
                        {
                            break;
                        }
                    }
                    case  SDLK_z://if lifeline is used
                    {
                        if (num<turns)//till when all players have not played at least ones
                        {
                            if(playerindex==1)
                            {
                                if(player1.count<1)//player has not used his lifeline
                                {
                                    int z;
                                    z=Grid[j][i];
                                    if(z==0)
                                    { turns++;
                                        executemove(j,i,Grid,playerindex,grid);
                                        player1.count++;//increase the count of lifeline
                                        //update the playerindex
                                        playerindex++;
                                        if(playerindex==num+1)
                                        {
                                            playerindex=1;
                                        }
                                        break;
                                    }
                                }
                            }
                            if(playerindex==2)
                            {
                                if(player2.count<1)
                                {
                                    int z;
                                    z=Grid[j][i];
                                    if(z==0)//if cell is empty
                                    {turns++;
                                        executemove(j,i,Grid,playerindex,grid);
                                        player2.count++;
                                        playerindex++;
                                        if(playerindex==num+1)
                                        {
                                            playerindex=1;
                                        }
                                        break;
                                    }
                                }
                            }
                            if(playerindex==3)
                            {
                                if(player3.count<1)
                                {
                                    int z;
                                    z=Grid[j][i];
                                    validatemove(playerindex,z);
                                    if(z==0)//if cell is empty
                                    {turns++;
                                        executemove(j,i,Grid,playerindex,grid);
                                        player3.count++;
                                        playerindex++;
                                        if(playerindex==num+1)
                                        {
                                            playerindex=1;
                                        }
                                        break;
                                    }

                                }
                            }
                            if(playerindex==4)
                            {
                                if(player4.count<1)
                                {
                                    int z;
                                    z=Grid[j][i];
                                    validatemove(playerindex,z);
                                    if(z==0)//if cell is empty
                                    {turns++;
                                        executemove(j,i,Grid,playerindex,grid);
                                        player4.count++;
                                        playerindex++;
                                        if(playerindex==num+1)
                                        {
                                            playerindex=1;
                                        }
                                        break;
                                    }

                                }
                            }
                        }
                    }
                    }
            }
            if(event.type==SDL_QUIT)//if window is closed
            {
                quit=false;
            }

            if(use==2)//if mouse is used
            {
                for(i=0; i<(grid); i++)
                {
                    for(j=0; j<grid; j++)
                    {
                        criticalmass[i][j]=3;//initialising critical mass of every cell to 3
                    }
                }
                for(j=0; j<grid; j++)//changing critical mass of edge cells to 2
                {
                    criticalmass[0][j]=2;
                    criticalmass[grid-1][j]=2;
                    criticalmass[j][0]=2;
                    criticalmass[j][grid-1]=2;
                }
                //changing critical mass of cells at corners =1
                {
                    criticalmass[0][0]=1;
                    criticalmass[0][grid-1]=1;
                    criticalmass[grid-1][grid-1]=1;
                    criticalmass[grid-1][0]=1;
                }
                switch(event.type)
                {
                case SDL_QUIT:
                    quit=false;
                    break;
                case SDL_MOUSEBUTTONDOWN://if mousebutton is pressed
                {
                    j=event.button.x;//x coordinate of cell
                    i=event.button.y;//y coordinate of cell
                    j=(j/64);
                    i=(i/48);
                    int z=Grid[j][i];
                    int mov=validatemove(playerindex,z);//validating the move
                    if(mov==0)//if move is valid
                    {
                        {
                            int atoms=z%10;//no of atoms in cell clicked
                            if(atoms<criticalmass[j][i])//if reaction is not to take place increase atom in the cell by one
                            {
                                Grid[j][i]=(playerindex*100+1+atoms);
                                playerindex++;//change current player
                                turns++;//increase total turns of players
                                if(playerindex==num+1)//playerindex crosses num bring it back to one
                                {
                                    playerindex=1;
                                }
                                break;
                            }
                            else//if reaction is to take place
                            {
                                Grid[j][i]=0;//empty the initial cell
                                executemove(j,i,Grid,playerindex,grid);//execute the reaction
                                turns++;//increase the total number of turns
                                //update playerindex
                                {
                                    playerindex++;
                                    if(playerindex==num+1)
                                    {
                                        playerindex=1;
                                    }
                                }

                                {
                                    //check for winning condition
                                    if(turns>num)//if all players have had their chance at least once
                                    {
                                        int z[5]= {0,0,0,0,0};//array for no of cells for every player
                                        for(int w=0; w<grid; w++)
                                        {
                                            for(int v=0; v<grid; v++)
                                            {
                                                int g=Grid[w][v]/100;//occupied playerid of cell
                                                if(g!=0)//if cell is occupied by some player
                                                    z[g]++;//update no of cells in the array
                                            }
                                        }
                                        int r=0;

                                        if(z[playerindex]==0)//if playerindex player is eliminated update playerindex
                                        {
                                            playerindex++;

                                            if(playerindex==(num+1))playerindex=1;
                                        }
                                        for(i=1; i<5; i++)
                                        {

                                            if(z[i]>0)
                                            {
                                                r++;
                                            }
                                        }
                                        if(r<2)//if only one player is remaining
                                        {
                                            for(i=1; i<5; i++)
                                            {
                                                if(z[i]>0)
                                                {
                                                    int a=i;//winner playerindex
                                                    gameoverscreen(a);
                                                }
                                            }
                                            SDL_QUIT;
                                            return ;
                                            break;
                                        }
                                        break;
                                    }
                                }
                            }
                        }
                    }
                    if(mov==-1)
                    {
                        break;
                    }
                }
                case SDL_MOUSEMOTION ://movement of marker
                {
                    p=event.motion.x;
                    q=event.motion.y;
                    p=(p/64)*64;
                    q=(q/48)*48;
                    applybutton(p,q,marker,screen);
                    break;
                }
                }
            }
        }
    }
    return;

}
int validatemove(int playerindex,int z)
{
    /*This function checks whether a requested move is applicable or not with respect to certain conditions.
       if the move is valid it returns 0 otherwise it returns -1.
           It is called from within gridmouse or gridkey functions.
       */
    if((playerindex==(z/100))||z==0)return 0;
    else return -1;
}
void executemove(int x,int y,int Grid[20][20],int &playerindex,int &grid)
{
    /*This function is called from within gridmouse or gridkey functions.
       It executes the move done  by a player after it has been validated by the validatemove function.
    */
    int criticalmass[10][10];//grid for  critical mass of every cell
    int j,i;
    //initializing every cell's critical mass =3
    for(i=0; i<(grid); i++)
    {
        for(j=0; j<grid; j++)
        {
            criticalmass[i][j]=3;
        }
    }
    //updating critical mass of cells on edge=2
    for(j=0; j<grid; j++)
    {
        criticalmass[0][j]=2;
        criticalmass[grid-1][j]=2;
        criticalmass[j][0]=2;
        criticalmass[j][grid-1]=2;
    }
    //updating criticalmass of corner cells=1
    criticalmass[0][0]=1;
    criticalmass[0][grid-1]=1;
    criticalmass[grid-1][grid-1]=1;
    criticalmass[grid-1][0]=1;
    void exec(int x,int y,int critical[10][10],int Grid[20][20],int playerindex,int grid);//declaration of exec function
    if(x<(grid-1))
    {
        exec(x+1,y,criticalmass,Grid,playerindex,grid);
    }
    if(x>0)
    {
        exec(x-1,y,criticalmass,Grid,playerindex,grid);
    }
    if(y>0)
    {
        exec(x,y-1,criticalmass,Grid,playerindex,grid);
    }

    if(y<(grid-1))
    {
        exec(x,y+1,criticalmass,Grid,playerindex,grid);
    }


    return;

}
void exec(int x,int y,int critical[10][10],int Grid[20][20],int playerindex,int grid)
{//This function is called from within the executemove function and it updates the Grid array according to the condition
     //grid=size of grid
    int i=((Grid[(x)][y])%100);//i=atoms present in the Grid[x][y]

    if(i<(critical[x][y]))//if reaction is not to take place
    {
        Grid[(x)][y]=((playerindex*100)+i+1);//increase atom in Grid[x][y] by 1
    }
    else//if reaction is to take place
    {
        Grid[(x)][y]=0;
        executemove((x),y,Grid,playerindex,grid);//call to executemove function
    }
    return;
}
void applybutton(int x,int y,SDL_Surface* source, SDL_Surface* destination )
{//This function applies the image according to given coordinates x and y
    //source = image to be applied
    //destination is the screen
    SDL_Rect offset;
    //coordinates of image

    offset.x = x;
    offset.y = y;
    SDL_BlitSurface( source, NULL, destination, &offset );//load image on destination
    return;
}
void displayinstructionscreen()
{
    SDL_Event e;
    SDL_Surface* backinstruction= NULL;
    SDL_Surface* screen= NULL;

    SDL_Init( SDL_INIT_EVERYTHING );

    if( SDL_Init( SDL_INIT_EVERYTHING ) == -1 )
    {
        return ;
    }
    SDL_WM_SetCaption( "INSTRUCTIONS FOR THE GAME", NULL );
    screen = SDL_SetVideoMode( 640, 480, 32, SDL_SWSURFACE );
    backinstruction=SDL_LoadBMP("instructionscreen.bmp");

        SDL_BlitSurface( backinstruction, NULL, screen, NULL );//load image on the screen
        SDL_Flip( screen );

    while(true)
    {
        if(SDL_PollEvent(&e))
        {
            if(e.type==SDL_MOUSEBUTTONDOWN)
                return;
        }
    }
}
void gameoverscreen(int a)
{
    /*This function displays the screen after the game is over.
       It displays the number of the player who won the game .*/
       //a=playerindex
    SDL_Event e;
    SDL_Surface* backgameover= NULL;
    SDL_Surface* player1wins= NULL;
    SDL_Surface* player2wins= NULL;
    SDL_Surface* player3wins= NULL;
    SDL_Surface* player4wins= NULL;
    SDL_Surface* screen= NULL;


    SDL_Init( SDL_INIT_EVERYTHING );

    if( SDL_Init( SDL_INIT_EVERYTHING ) == -1 )
    {
        return ;
    }

    SDL_WM_SetCaption( "GAMEOVER", NULL );
    screen = SDL_SetVideoMode( 640, 480, 32, SDL_SWSURFACE );
    backgameover= SDL_LoadBMP("gameover.bmp");
    player1wins= SDL_LoadBMP("p1.bmp");
    player2wins= SDL_LoadBMP("p2.bmp");
    player3wins= SDL_LoadBMP("p3.bmp");
    player4wins= SDL_LoadBMP("p4.bmp");


    SDL_BlitSurface(backgameover,NULL,screen,NULL);


    SDL_Flip(screen);
    while (true)
    {//apply image according to playerindex
        if (a==1)
        {
            applybutton(160,240,player1wins,screen );
            SDL_Flip(screen);
        }
        if (a==2)
        {
            applybutton(160,240,player2wins,screen );
            SDL_Flip(screen);
        }
        if (a==3)
        {
            applybutton(160,240,player3wins,screen );
            SDL_Flip(screen);
        }
        if (a==4)
        {
            applybutton(160,240,player4wins,screen );
            SDL_Flip(screen);
        }


        if(SDL_PollEvent(&e))
        {
            if( e.type == SDL_KEYDOWN )
                switch( e.key.keysym.sym )
                {
                case SDLK_a:
                {
                    SDL_FreeSurface( backgameover );
                    SDL_FreeSurface( player1wins );
                    SDL_FreeSurface( player2wins );
                    SDL_FreeSurface( player3wins );
                    SDL_FreeSurface( player4wins );

                    return;
                }
                }
        }
    }


}
void applyimage(int a,int b,int &playerindex,SDL_Surface* atoms, SDL_Surface* destination)
{//apply the image on screen at given coordinates(a,b)singleback-colour is the background image of given colour,
    //atoms->no of atoms present in the given cell
    SDL_Surface* singlebackblue;
    SDL_Surface* singlebackyellow;
    SDL_Surface* singlebackred;
    SDL_Surface* singlebackgreen;
    SDL_Surface* source;
    SDL_Init( SDL_INIT_EVERYTHING );
    singlebackblue=SDL_LoadBMP("singlebackblue.bmp");
    singlebackyellow=SDL_LoadBMP("singlebackyellow.bmp");
    singlebackred=SDL_LoadBMP("singlebackred.bmp");
    singlebackgreen=SDL_LoadBMP("singlebackgreen.bmp");
    {//choose background according to playerindex
        if(playerindex==1)
    {
        source=singlebackblue;
    }
    if(playerindex==2)
    {
        source=singlebackyellow;
    }
    if(playerindex==3)
    {
        source=singlebackred;
    }
    if(playerindex==4)
    {
        source=singlebackgreen;
    }}
    SDL_Rect off;
    off.x = a*64;
    off.y =b*48;
    SDL_BlitSurface(source,NULL,destination,&off);//change surface
    SDL_BlitSurface(atoms,NULL,destination,&off);
    Uint32 colorkey = SDL_MapRGB( atoms->format, 0x00, 0x00, 0x00 );
    SDL_SetColorKey( atoms, SDL_SRCCOLORKEY, colorkey );
    SDL_Flip(destination);
    return;
}
